#ifndef _expatll_h_
#define _expatll_h_
#include "xmltok.h"
#include "xmlrole.h"
#include <Python.h>


#ifdef __cplusplus
extern "C" {
#endif

/*
Another generally useful object type is an tuple of object pointers.
This is a mutable type: the tuple items can be changed (but not their
number).  Out-of-range indices or non-tuple objects are ignored.

*** WARNING *** PyTuple_SetItem does not increment the new item's reference
count, but does decrement the reference count of the item it replaces,
if not nil.  It does *decrement* the reference count if it is *not*
inserted in the tuple.  Similarly, PyTuple_GetItem does not increment the
returned item's reference count.
*/

#define XmlItem_startTag  1
#define XmlItem_endTag  2
#define XmlItem_data  3
#define XmlItem_cdata 4
#define XmlItem_emptyElement 5
#define XmlItem_comment 6
#define XmlItem_carriage 7
#define XmlItem_PI 8
#define XmlItem_XmlDecl 9
#define XmlItem_unknown -1
#define XmlItem_partial 0

typedef struct XmlItem_c {
	int type;
	int len;
	PyObject* attrs;
	PyObject* tag;
	PyObject* prefix;
	PyObject* value;

};

extern void expatll_parse(struct XmlItem_c* item, char* start, char* end, char** next);
extern void initexpatll(void);

#ifdef __cplusplus
}
#endif
#endif 
