#include "xlistobject.h"

static PyObject*
xlisttypeinfo_init(PyXList_TypeInfo *self, PyObject* args) {
	self->tag = Py_None;
	self->uri = Py_None;
	self->prefix = Py_None;
	self->attributes_factories = Py_None;
	self->items_DFA = Py_None;
}

static PyObject *
xlisttypeinfo_tag_get(PyXList_TypeInfo *self)
{
	return self->tag;
}

static PyObject *
xlisttypeinfo_tag_set(PyXList_TypeInfo *self, PyObject* args)
{
	if (!PyArg_ParseTuple(args, "O!", &PyString_Type, &self->tag))
		return NULL;
	Py_INCREF(Py_None);
	return Py_None;
}


static PyObject *
xlisttypeinfo_uri_get(PyXList_TypeInfo *self)
{
	return self->uri;
}

static PyObject *
xlisttypeinfo_uri_set(PyXList_TypeInfo *self, PyObject* args)
{
	if (!PyArg_ParseTuple(args, "O!", &PyString_Type, &self->uri))
		return NULL;
	Py_INCREF(Py_None);
	return Py_None;
}

static PyObject *
xlisttypeinfo_prefix_get(PyXList_TypeInfo *self)
{
	return self->prefix;
}

static PyObject *
xlisttypeinfo_prefix_set(PyXList_TypeInfo *self, PyObject* args)
{
	if (!PyArg_ParseTuple(args, "O!", &PyString_Type, &self->prefix))
		return NULL;
	Py_INCREF(Py_None);
	return Py_None;
}

static PyObject *
xlisttypeinfo_attributes_factories_get(PyXList_TypeInfo *self)
{
	return self->attributes_factories;
}

static PyObject *
xlisttypeinfo_attributes_factories_set(PyXList_TypeInfo *self, PyObject* args)
{
	if (!PyArg_ParseTuple(args, "O!", &PyString_Type, &self->attributes_factories))
		return NULL;
	Py_INCREF(Py_None);
	return Py_None;
}

static PyObject *
xlisttypeinfo_items_DFA_get(PyXList_TypeInfo *self)
{
	return self->uri;
}

static PyObject *
xlisttypeinfo_items_DFA_set(PyXList_TypeInfo *self, PyObject* args)
{
	if (!PyArg_ParseTuple(args, "O!", &PyString_Type, &self->uri))
		return NULL;
	Py_INCREF(Py_None);
	return Py_None;
}

static PyGetSetDef xlisttypeinfo_getsets[] = {
	{"tag", (getter)xlisttypeinfo_tag_get, (setter)xlisttypeinfo_tag_set,
	 "the xlist tag"},
	{"uri", (getter)xlisttypeinfo_uri_get, (setter)xlisttypeinfo_uri_set,
	 "the xlist uri"},
	{"prefix", (getter)xlisttypeinfo_prefix_get, (setter)xlisttypeinfo_prefix_set,
	 "the xlist default prefix"},
	{"attributes_factories", (getter)xlisttypeinfo_attributes_factories_get, (setter)xlisttypeinfo_attributes_factories_set,
	 "the attributes template for the xlist"},
	{"items_DFA", (getter)xlisttypeinfo_items_DFA_get, (setter)xlisttypeinfo_items_DFA_set,
	 "a deterministic finite automate that describes the xlist valid content"},
	{0}
};


static 
PyTypeObject PyXListTypeInfo_Type = {
	PyObject_HEAD_INIT(DEFERRED_ADDRESS(&PyType_Type))
	0,
	"xlist_typeinfo",
	sizeof(spamlistobject),
	0,
	0,					/* tp_dealloc */
	0,					/* tp_print */
	0,					/* tp_getattr */
	0,					/* tp_setattr */
	0,					/* tp_compare */
	0,					/* tp_repr */
	0,					/* tp_as_number */
	0,					/* tp_as_sequence */
	0,					/* tp_as_mapping */
	0,					/* tp_hash */
	0,					/* tp_call */
	0,					/* tp_str */
	0,					/* tp_getattro */
	0,					/* tp_setattro */
	0,					/* tp_as_buffer */
	Py_TPFLAGS_DEFAULT  /* tp_flags */
	0,					/* tp_doc */
	0,					/* tp_traverse */
	0,					/* tp_clear */
	0,					/* tp_richcompare */
	0,					/* tp_weaklistoffset */
	0,					/* tp_iter */
	0,					/* tp_iternext */
	0,			/* tp_methods */
	0,					/* tp_members */
	xlisttypeinfo_getsets,			/* tp_getset */
	0,		/* tp_base */
	0,					/* tp_dict */
	0,					/* tp_descr_get */
	0,					/* tp_descr_set */
	0,					/* tp_dictoffset */
	(initproc)xlisttypeinfo_init,		/* tp_init */
	0,					/* tp_alloc */
	0,					/* tp_new */
};

void initxlist() {
	PyXList_TypeInfo* xlist_typeinfo;


	PyXListTypeInfo_Type.ob_type = &PyType_Type;
	if (PyType_Ready(PyXListTypeInfo_Type) < 0)
		return;;
	
	__tag__ = PyString_FromString("xlist");
	__uri__ = PyString_FromString("http://satine.sourceforge.net/schemas/kernel");
	__dict__ = PyString_FromString("__dict__");

	xlist_typeinfo = (PyXList_TypeInfo) PyObject_New(PyXList_TypeInfo, &PyXListTypeInfo_Type);
	xlist_typeinfo->tag = PyString_FromString("xlist");
	xlist_typeinfo->uri = PyString_FromString("http://satine.sourceforge.net/schemas/kernel");
	xlist_typeinfo->prefix = PyString_FromString("satine");

	
}