__all__ = ["xlisttest"]

import unittest
import xlisttest
import streamtest
import dbtest
import furthertest

class Runner:
    def __init__(self, modules):
        loader = unittest.TestLoader()
        self.runner = unittest.TextTestRunner()
        self.testSuites = []
        for m in modules:
            self.testSuites.append(loader.loadTestsFromModule(m))

    def test(self, result):        
        for testSuite in self.testSuites:
            testSuite.run(result)

    def run(self):
        self.runner.run(self.test)

def basic():
    runner = Runner([xlisttest, streamtest, dbtest])
    runner.run()    
        
def full():
    runner = Runner([xlisttest, streamtest, dbtest, furthertest])
    runner.run()    
        
if __name__ == "__main__":
    run()