import satine
import unittest
import gc
import satine.schemas.soap
import satine.test
import os
import odbc
from satine import schemaclib

def openfile(filename):
    testpath = satine.test.__path__[0]
    filename = testpath+os.sep+filename
    return open(filename)

class LoadAndVisit(unittest.TestCase):
    def loadAndVisit(self, name):
        file = openfile(name)
        py = satine.xml2py(file.read())
        ecount = 0
        acount = 0
        acount, ecount = self.visit(py, acount, ecount)
        return (acount, ecount)

    def visit(self, obj, acount, ecount):
        for i in obj.__dict__:
            ghost = obj[i]
            acount += 1
        for i in obj:
            ecount += 1
            if satine.is_xlist(i):
                acount, ecount = self.visit(i, acount, ecount)
        return acount, ecount 
       
    def testJungle(self):
        acount, ecount = self.loadAndVisit('jungle.xml')
        self.assertEqual((acount, ecount), (120, 2624))
        
        acount, ecount = self.loadAndVisit('xhtml.xsd')
        self.assertEqual((acount, ecount), (1219, 882))
    
class Validation(unittest.TestCase):
    def testSchemaclib(self):
        doc = openfile('2511B39.xsd').read()
        code = schemaclib.pythonc().compile(doc,"time", "http://satine.sourceforge.net/tmp/2511B39.xsd")
        self.assertEqual(len(code), 90214)

class ODBCEnable(unittest.TestCase):
    def testODBS(self):
        try:
            odbc.odbc("satine_dbtest")
        except:
            print """\n\nWARNING!!! In order to test db features, please create an empty ODBC
                    database with identifier 'satine_dbtest'\n\n"""
        

if __name__ == "__main__":
    unittest.main()        